package main

import "fmt"

type Node struct {
	Content string
	Next *Node
}

func PrintList(first *Node) {
	var curs *Node
	curs = first
	for curs != nil {
		if curs.Next != nil {
			fmt.Printf("%s -> ", curs.Content)    // in C: curs->Content
		} else {
			fmt.Printf("%s", curs.Content)
		}
		curs = curs.Next
	}
	fmt.Println()
}

func Length(first *Node) int {
	var curs *Node
	c := 0
	curs = first
	for curs != nil {
		c++
		curs = curs.Next
	}
	return c
}

func AddFirst(first *Node, x string) *Node {
	nuovo := new(Node)
	nuovo.Content = x 
	nuovo.Next = first 
	return nuovo
}

func AddLast(first *Node, x string) *Node {
	var curs, prev *Node
	nuovo := new(Node)
	nuovo.Content = x 
	nuovo.Next = nil 
	// Scandisco la lista alla ricerca dell'ultimo nodo
	prev = nil
	curs = first
	for curs != nil {
		prev = curs
		curs = curs.Next
	}	
	if prev != nil {
		prev.Next = nuovo
		return first
	} else {
		return nuovo 
	}
}

 func AddInOrder(first *Node, x string) *Node {
	var curs, prev *Node
	nuovo := new(Node)
	nuovo.Content = x 
	// Scandisco la lista alla ricerca del primo nodo >=x
	prev = nil
	curs = first
	for curs != nil && curs.Content < x {
		prev = curs
		curs = curs.Next
	}	
	if prev == nil {   // Sto attaccando in testa (o su una lista vuota)
		nuovo.Next = first 
		return nuovo 
	} else {
		prev.Next = nuovo
		nuovo.Next = curs 
		return first 
	}

 }


func main() {
	var first *Node
	first = AddInOrder(first, "Pappa")
	first = AddInOrder(first, "Pomodoro")
	first = AddInOrder(first, "La")
	first = AddInOrder(first, "Cagna")
	first = AddInOrder(first, "Topino")
	first = AddInOrder(first, "Carta")
	first = AddInOrder(first, "Zuppa")
	first = AddInOrder(first, "Aceto")
	first = AddInOrder(first, "Machete")
	PrintList(first)
	fmt.Printf("Lunghezza: %d\n", Length(first))
}

func vecchio_main() {
	var first, second, third *Node
	first = new(Node)
	second = new(Node)
	third = new(Node)
	first.Content = "Primo"
	second.Content = "Secondo"
	third.Content = "Terzo"
	first.Next = second
	second.Next = third
	third.Next = nil

	PrintList(first)
	fmt.Printf("Lunghezza: %d\n", Length(first))

	first = AddFirst(first, "Zero")
	PrintList(first)
	fmt.Printf("Lunghezza: %d\n", Length(first))

	first = AddLast(first, "Ultimo")
	PrintList(first)
	fmt.Printf("Lunghezza: %d\n", Length(first))
}

